
resource "aws_iam_role" "lambda_jsonapi" {
  name = "lambda_jsonapi"
  path = "/"

  assume_role_policy = <<POLICY
{
  "Version": "2012-10-17",
  "Statement": [
    {
      "Effect": "Allow",
      "Principal": {
        "Service": "lambda.amazonaws.com"
      },
      "Action": "sts:AssumeRole"
    }
  ]
}
POLICY
}

resource "aws_iam_role_policy_attachment" "lambda_jsonapi_AmazonDynamoDBFullAccess" {
  role       = "${aws_iam_role.lambda_jsonapi.name}"
  policy_arn = "arn:aws:iam::aws:policy/AmazonDynamoDBFullAccess"
}

resource "aws_iam_role_policy_attachment" "lambda_jsonapi_CloudWatchFullAccess" {
  role       = "${aws_iam_role.lambda_jsonapi.name}"
  policy_arn = "arn:aws:iam::aws:policy/CloudWatchFullAccess"
}
